﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "AI_RestrictedZone.h"

#include "EndlessVendetta/EndlessVendettaCharacter.h"


// Sets default values
AAI_RestrictedZone::AAI_RestrictedZone()
{
	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
	BoxCollision = CreateDefaultSubobject<UBoxComponent>(TEXT("BoxCollision"));
}

// Called when the game starts or when spawned
void AAI_RestrictedZone::BeginPlay()
{
	Super::BeginPlay();
	BoxCollision->OnComponentBeginOverlap.AddDynamic(this, &AAI_RestrictedZone::OnBoxOverlapBegin);
	BoxCollision->OnComponentEndOverlap.AddDynamic(this, &AAI_RestrictedZone::OnBoxOverlapEnd);
}

void AAI_RestrictedZone::OnBoxOverlapBegin(UPrimitiveComponent* OverlappedComp, AActor* OtherActor, UPrimitiveComponent* OtherComp, int32 OtherBodyIndex, bool bFromSweep, const FHitResult& SweepResult)
{
	if (Cast<AEndlessVendettaCharacter>(OtherActor))
	{
		UE_LOG(LogTemp, Display, TEXT("Player entered restricted bounds"));
		Cast<AEndlessVendettaCharacter>(OtherActor)->IncrementRestrictedBoundsCount();
	}
}

void AAI_RestrictedZone::OnBoxOverlapEnd(UPrimitiveComponent* OverlappedComp, AActor* OtherActor, UPrimitiveComponent* OtherComp, int32 OtherBodyIndex)
{
	if (Cast<AEndlessVendettaCharacter>(OtherActor))
	{
		UE_LOG(LogTemp, Display, TEXT("Player left restricted bounds"));
		Cast<AEndlessVendettaCharacter>(OtherActor)->DecrementRestrictedBoundsCount();
	}
}

// Called every frame
void AAI_RestrictedZone::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}
